#include "mbed.h"

PwmOut speaker(p21);
float frequency = 800;
float wait_time = 1.000; 
InterruptIn boom(p5);
void detonation();
    
int main() 
{    
    boom.rise(&detonation);
    while(1)
    {
        speaker.period(1.0/(2.0*frequency));
        speaker = 0.5;
        wait(0.15);
        speaker = 0;
        wait(0.35);
        speaker.period(1.0/(2.0*(frequency + 100)));
        speaker = 0.5;
        wait(0.15);
        speaker = 0;
        wait(wait_time);
        frequency++;
        wait_time = wait_time - 0.002;
    }    
}

void detonation()
{
    for(int i = 0; i < 20; i++)
    {
        speaker.period(1.0/(2.0*frequency + 100));
        speaker = 0.5;
        wait(0.05);
        speaker = 0;
        wait(0.02);
        speaker.period(1.0/(2.0*(frequency + 100)));
        speaker = 0.5;
        wait(0.05);
        speaker = 0;
        wait(0.02);
    }
        speaker.period(1.0/(2.0*200));
        speaker = 0.4;
        wait(2);
    
}